#Include Once "fbgfx.bi"
#Include Once "coldata.bi"
#Include Once "generic.bas"

Dim Shared As Long PBack(1, 23531), ABack(1, 2, 793)
Dim Shared TBack(1, 2) As String * 1, TPos(1, 2) As Integer
Dim Shared As Integer Page(1)

Function LenStr (ByRef s As String) As Integer
  Dim As Integer i, x = 0
  For i = 1 To Len(s)
    x += alphas(alindex(Instr(NameStr, Mid(s, i, 1)) - 1) + 2)
  Next i
  LenStr = x
End Function

Sub Frame (ByVal x1 As Integer, ByVal y1 As Integer, ByVal x2 As Integer, ByVal y2 As Integer)
  Line (x1, y1)-(x2, y2), 17, b
  Line (x1 + 1, y1 + 1)-(x2 - 1, y2 - 1), 22, b
End Sub

Sub PrintStr (ByVal x As Integer, ByVal y As Integer, ByRef t As String)
  Dim As Integer i, cpos
  For i = 1 To Len(t)
    cpos = Instr(NameStr, Mid(t, i, 1)) - 1 
    Put (x, y), alphas(alindex(cpos)), Trans
    x = x + alphas(alindex(cpos)+2)
  Next i
End Sub
#Define PrintStrRight(x, y, s) PrintStr((x)-LenStr(s), (y), (s))

Sub ShowJewel (ByVal Player As Integer, ByVal x As Integer, ByVal y As Integer, ByVal n As Integer)
  Put (408 - Player * 404 + 38 * x, 422 - 38 * y), blk(n, 0), PSet
End Sub

Sub ShowName (ByVal Player As Integer, ByVal Place As Integer, ByVal Sel As Integer)
  Dim As Integer i, x, xlen, endP
  If TBack(Player, 0) <> Chr(0) Then
    xlen = LenStr(Mid(Game(Player).Ini, Place, 1))
    endP = IIf(xlen = LenStr(TBack(Player, Place - 1)), Place, 3)
    For i = Place To 3
      Put (484 - 404 * Player + TPos(Player, i - 1), 264), ABack(Player, i - 1, 0), PSet
    Next i
  Else
    endP = Place
  End If
  For i = Place To 3
    TBack(Player, i - 1)[0] = Game(Player).Ini[i-1]
    xlen = LenStr(TBack(Player, i - 1))
    x = IIf(Player, 80, 484) + TPos(Player, i - 1)
    Get (x, 264)-Step(xlen - 1, 47), ABack(Player, i - 1, 0)
    PrintStr x, 264, TBack(Player, i - 1)
    If i <> 3 Then TPos(Player, i) = TPos(Player, i - 1) + xlen
    If i = Place And Sel Then
      Line (x, 310)-Step(xlen - 1, 1), 192, b
    End If
  Next i
  Exit Sub
End Sub

Sub ClearNext (ByVal Player As Integer)
  Dim As Integer i
  For i = 0 To 2
    Put (354 - Player * 106, 80 - 38 * i), blk(0, 0), PSet
  Next i
End Sub

Sub ClGOverMes (ByVal Player As Integer)
  Dim As Integer x, y
  For y = 6 To 4 Step -1
    For x = 1 To 4
      ShowJewel(Player, x, y, 0)
    Next x
  Next y
End Sub

Sub ClShowHigh (ByVal Player As Integer)
  Dim As Integer x, y
  If Page(Player) Then
    For y = 10 To 1 Step -1
      For x = 0 To 5
        ShowJewel(Player, x, y, 0)
      Next x
    Next y
  End If
  Page(Player) = 0
End Sub

Sub DrawBoard ()

  Dim As Integer i, x, y
  Frame 0, 0, 235, 463
  Frame 404, 0, 639, 463
  For y = 11 To 0 Step -1
    For i = 0 To 1
      For x = 0 To 5
        ShowJewel(i, x, y, 0)
      Next x
    Next i
  Next y

  Frame 350, 0, 395, 121
  Frame 244, 0, 290, 121
  PrintStr 296, 1, "N"
  PrintStr 322, 25, "E"
  PrintStr 296, 49, "X"
  PrintStr 322, 73, "T"
  ClearNext 0: ClearNext 1

  Frame 244, 143, 395, 217
  Put (283, 172), scrimg1, PSet

  Frame 244, 239, 395, 271
  Put (287, 247), scrimg2, PSet

  Frame 244, 293, 395, 367
  Put (297, 322), scrimg3, PSet

  Frame 244, 389, 395, 463
  Put (276, 418), scrimg4, PSet

End Sub

Sub GameOverMessage (ByVal Player As Integer)
  Dim As Integer i, x, y
  For y = 8 To 3 Step -1
    For x = 1 To 4
      ShowJewel(Player, x, y, 0)
    Next x
  Next y
  For i = 0 To 2
    TBack(Player, i) = Chr(0)
  Next i
  PrintStr 470 - Player * 404, 192, "GAME"
  PrintStr 472 - Player * 404, 240, "OVER"
  PBack(Player, 0) = 0
End Sub

Sub GrEnd ()
  'nothing to do
End Sub

Sub GrInit ()

  Dim As Integer i

  ' set screen mode and palette
  Screen 18, 8, , fb.GFX_WINDOWED ' 640x480x8
  If (ScreenPtr = 0) Then
    Print "error: graphics screen not initialized."
    End -1
  End If
  Palette Using Pal                   

End Sub

Sub HighMessage (ByVal Player As Integer)

  Dim As String a
  Dim As Integer i, x, xlen

  PrintStr 478 - 404 * Player, 120, "HIGH"
  PrintStr 459 - 404 * Player, 168, "SCORE"
  a = getPlace(Game(Player).Place)
  If PBack(Player, 0) Then Put (522 - Player * 404 - PBack(Player, 2) \ 2, 216), PBack(Player, 0), PSet
  xlen = LenStr(a)
  x = 522 - Player * 404 - LenStr(a) \ 2
  Get (x, 216)-Step(xlen - 1, 47), PBack(Player, 0)
  PrintStr x, 216, a
  For i = 1 To 3
    ShowName Player, i, (Game(Player).PlaceStatus And 3) = i
  Next i
End Sub

Sub OutMessage (ByVal Player As Integer)
  Dim As Integer i, x, y
  For y = 8 To 3 Step -1
    For x = 1 To 4
      ShowJewel(Player, x, y, 0)
    Next x
  Next y
  For i = 0 To 2
    TBack(Player, i) = Chr(0)
  Next i
  PBack(Player, 0) = 0
End Sub

Sub PrintDiff (ByVal Player As Integer)
  Dim As Integer a, l, x, y
  a = Game(Player).Diff
  l = diffs(diffindex(a) + 2)
  x = 345 - 93 * Player
  y = 343 - 42 * Player
  If l < 43 Then
    If l < 42 Then
      Line (x, y)-Step((41 - l) \ 2, 16), 0, bf
    End If
    Line (x + (43 + l) \ 2, y) - (x + 42, y + 16), 0, bf
    x += (43 - l) \ 2
  End If
  Put (x, y), diffs(diffindex(a)), PSet
End Sub

Sub PrintJewels (ByVal Player As Integer)

  Dim As Integer a, b, i, j, k, x, y

  a = Game(Player).Jewels
  If a = 0 Then
    x = 341 - 73 * Player
    y = 439 - 42 * Player
    Line (x, y)-Step(30, 16), 0, bf
  End If
  If Player = 0 Then
    Do
      Put (373 - 16 * i, 439), nos(a Mod 10, 0), PSet
      a \= 10
      i += 1
    Loop While a
  Else
    b = a
    Do
      b \= 10
      i += 1
    Loop While b
    For j = 0 To i - 1
      Put (236 + 16 * (i - j), 397), nos(a Mod 10, 0), PSet
      a \= 10
    Next j
  End If

End Sub

Sub PrintLv (ByVal Player As Integer)
  Put (IIf(Player, 252, 373), 247), nos(Game(Player).CurLv, 0), PSet
End Sub

Sub PrintScore (ByVal Player As Integer)

  Dim As Integer a, b, i, j, k, x, y

  a = Game(Player).Score
  If a = 0 Then
    x = 293 - 25 * Player
    y = 193 - 42 * Player
    Line (x, y)-Step(78, 16), 0, bf
  End If
  If Player = 0 Then
    Do
      Put (373 - 17 * i, 193), nos(a Mod 10, 0), PSet 
      a \= 10
      i += 1
    Loop While a
  Else
    b = a
    Do
      b \= 10
      i += 1
    Loop While b
    For j = 0 To i - 1
      Put (236 + 16 * (i - j), 151), nos(a Mod 10, 0), PSet
      a \= 10
    Next j
  End If

End Sub

Sub ShowHigh (ByVal Player As Integer)

  Dim As String a
  Dim As Integer x, y

  If Page(Player) Then
    For y = 10 To 1 Step -1
      For x = 0 To 5
        ShowJewel(Player, x, y, 0)
      Next x
    Next y
  End If

  Page(Player) = (Page(Player) + 1) Mod 11
  If Page(Player) Then
    If High(Game(Player).Diff, Page(Player)).Score = 0 Then
      Page(Player) = 0
      Exit Sub
    End If
    
    x = IIf(Player, 26, 430)

    PrintStr x, 72, getPlace(Page(Player))
    a = High(Game(Player).Diff, Page(Player)).Ini 
    PrintStrRight(IIf(Player, 209, 613), 120, a)

    PrintStr x, 184, "SCORE"
    a = Str(High(Game(Player).Diff, Page(Player)).Score)
    PrintStrRight(IIf(Player, 209, 613), 232, a)

    PrintStr x, 296, "JEWELS"
    a = Str(High(Game(Player).Diff, Page(Player)).Jewels)
    PrintStrRight(IIf(Player, 209, 613), 344, a)

  End If
End Sub

Sub ShowNext (ByVal Player As Integer)
  Dim As Integer i
  For i = 0 To 2
    Put (IIf(Player, 248, 354), 80 - 38 * i), blk(Game(Player).NextJewel(i), 0), PSet
  Next i
End Sub